# -*- coding: utf-8 -*-

# mapWOC
#
# Description: Visits, Results and ResultType Classes.
#
# Authors:
# Felix Wolfsteller <felix.wolfsteller@intevation.de>
#
# Copyright:
# Copyright (C) 2011 Bundesamt für Sicherheit in der Informationstechnik
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2,
# or, at your option, any later version as published by the Free
# Software Foundation
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.

# Testing symbolic links for model.

import datetime

class ResultType(object):

    def __init__(self, name, severity):
        self.type_name = name
        self.severity = severity

# TODO One 'Visit' might have several results.

class Result(object):

    def __init__(self, url=None, result_type=None, method='', date_time=None):
        """Creates a new result.
            url - The URL that this Result relates to.
            result_type - The ResultType of this Result.
            method - The method string of this Result.
            date_time - Time of finding. Is set to datetime.now() if None.
        """
        self.url = url
        if date_time is None:
            self.date = datetime.datetime.now()
        else:
            self.date = date_time
        self.extracts = []
        self.result_type = result_type
        self.text = None
        self.method = method


class Visit(object):
    def __init__(self, hc):
        self.hc = hc
        self.results = []
        self.dump_location = None

